﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Linq;

namespace DataTemplatesAndConverters2010
{
    public class DecadeConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            int year = ((DateTime)value).Year;
            return string.Format("{0}0s", year.ToString().Substring(0, 3));
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class RatingConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            int rating = (int)value;
            return string.Format("{0}/10 Stars", rating.ToString());
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class RatingStarConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            int rating = (int)value;
            string output = string.Empty;
            return output.PadLeft(rating, '*');
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string input = (string)value;
            //int rating = 0;

            //foreach (var ch in input)
            //    if (ch == '*')
            //        rating++;

            //return rating;

            return input.Count(c => c == '*');
        }
    }

    public class DecadeBrushConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            int year = ((DateTime)value).Year;

            if (year >= 1970 && year < 1980)
                return new SolidColorBrush(Colors.Green);
            if (year >= 1980 && year < 1990)
                return new SolidColorBrush(Colors.Blue);
            if (year >= 1990 && year < 2000)
                return new SolidColorBrush(Colors.Red);
            if (year >= 2000 && year < 2010)
                return new SolidColorBrush(Colors.Cyan);
            else
                return new SolidColorBrush(Colors.Black);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
